MODULE_NAME='Clearone StreamNet UI Module v1_0' (DEV dvPanel, DEV vdvStreamNet, DEV dvRendererZones[16])
(***********************************************************)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 04/04/2006  AT: 11:33:16        *)
(***********************************************************)
(* System Type : NetLinx                                   *)
(***********************************************************)
(* REV HISTORY:                                            *)
(***********************************************************)
(*
    $History: $
*)    
(***********************************************************)
(*          DEVICE NUMBER DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_DEVICE

(***********************************************************)
(*                INCLUDE DEFINITIONS GO BELOW             *)
(***********************************************************)
#INCLUDE 'SNAPI'

(***********************************************************)
(*               CONSTANT DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_CONSTANT

////////////////////////////////////////////////////////////
// CUSTOM API
////////////////////////////////////////////////////////////
AV_MODE_ON = 301;
AV_MODE_OFF = 302;
AV_MODE_CYCLE = 303;
AV_MODE_FB = 301;
	
MROOM_SESSION_ACTIVE_ON = 310;
MROOM_SESSION_ACTIVE_OFF = 311;
MROOM_SESSION_ACTIVE_CYCLE = 312;
	
MROOM_SESSION_ACTIVE_FB = 310;
	
SLEEPING_FB = 321;
HAS_AUDIO_CONTROL = 322;

IS_CONFIGURED = 330;

////////////////////////////////////////////////////////////
// MAX STUFF
////////////////////////////////////////////////////////////
MAX_NAME_SIZE = 50;
MAX_SOURCES = 128;
MAX_RENDERERS = 16;

////////////////////////////////////////////////////////////
// SOURCE CONTROL
////////////////////////////////////////////////////////////
SOURCE_PAGE_SIZE = 5;

////////////////////////////////////////////////////////////
// TIMELINES
////////////////////////////////////////////////////////////
TL_FEEDBACK = 1;
LONG FEEDBACK_TIMES[] = {300};

(***********************************************************)
(*              DATA TYPE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_TYPE

STRUCTURE _PAGE_LIST
{
	INTEGER nQtyOfPages;
	INTEGER nCurrentPage;
	INTEGER nQtyEntriesOnLastPage;
	INTEGER nCurrentCount;
	CHAR Is_Top;
	CHAR Is_Bottom;
}

STRUCTURE _RENDERER_INFO
{
	INTEGER nCurrentInput;
	INTEGER nCurrentVolumeLevel;
	CHAR cName[MAX_NAME_SIZE];
}

(***********************************************************)
(*               VARIABLE DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_VARIABLE

////////////////////////////////////////////////////////////
// GENERAL
////////////////////////////////////////////////////////////
INTEGER X;
INTEGER nButton;
DEV dvNull;

////////////////////////////////////////////////////////////
// SOURCE CONTROL
////////////////////////////////////////////////////////////
VOLATILE _PAGE_LIST uPageListCtrl;
VOLATILE INTEGER nSourceCount;
VOLATILE CHAR cSourceNames[MAX_SOURCES][MAX_NAME_SIZE];

////////////////////////////////////////////////////////////
// RENDERER INFO
////////////////////////////////////////////////////////////

VOLATILE _RENDERER_INFO uRendererInfo[MAX_RENDERERS];

////////////////////////////////////////////////////////////
// ZONES
////////////////////////////////////////////////////////////
VOLATILE DEV dvSelectedZone;           

////////////////////////////////////////////////////////////
// ZONE SELECTION
////////////////////////////////////////////////////////////
VOLATILE INTEGER nZoneSelectBtns[] = 
{
	101,															// Zone 01
	102,															// Zone 02
	103,															// Zone 03
	104,															// Zone 04
	105,															// Zone 05
	106,															// Zone 06
	107,															// Zone 07
	108,															// Zone 08
	109,															// Zone 09
	110,															// Zone 10
	111,															// Zone 11
	112,															// Zone 12
	113,															// Zone 13
	114,															// Zone 14
	115,															// Zone 15
	116 															// Zone 16
}                                       

////////////////////////////////////////////////////////////
// ZONE CONTROL - Source Selection
////////////////////////////////////////////////////////////
VOLATILE INTEGER nSelectedSource;
VOLATILE INTEGER nSelectSourceBtns[] = 
{
	1,																// [Source Name 1]
	2,																// [Source Name 2]
	3,																// [Source Name 3]
	4,																// [Source Name 4]
	5 																// [Source Name 5]
}

VOLATILE INTEGER nPageControlBtns[] = 
{
	7,																// TOP
	8,																// BOTTOM
	9,																// UP
	10																// DOWN
}

VOLATILE INTEGER nSelectedSourceBtn = 6;

VOLATILE CHAR  cSourcePage[SOURCE_PAGE_SIZE][MAX_NAME_SIZE];

////////////////////////////////////////////////////////////
// SELECTED RENDERER CONTROL
////////////////////////////////////////////////////////////
VOLATILE INTEGER nSelectedAVModeBtn = 11;
VOLATILE INTEGER nSelectedMultiRoomBtn = 12;

VOLATILE INTEGER nSelectedVolumeCtrlBtns[] = 
{
	13,																// VOLUME UP
	14,																// VOLUME DN
	15																// VOLUME MUTE
}

VOLATILE INTEGER nSelectedVolumeCtrlBargraph = 1;

////////////////////////////////////////////////////////////
// SELECTED RENDERER TEXT ADDRESSES
////////////////////////////////////////////////////////////
VOLATILE INTEGER nSelectedSourceNameText = 22;
VOLATILE INTEGER nSelectedRendererNameText = 21;

////////////////////////////////////////////////////////////
// DEDICATED RENDERER TEXT ADDRESSES
////////////////////////////////////////////////////////////
VOLATILE INTEGER nRendererZoneSelectText[] = 
{
	101,															// Zone 01
	102,															// Zone 02
	103,															// Zone 03
	104,															// Zone 04
	105,															// Zone 05
	106,															// Zone 06
	107,															// Zone 07
	108,															// Zone 08
	109,															// Zone 09
	110,															// Zone 10
	111,															// Zone 11
	112,															// Zone 12
	113,															// Zone 13
	114,															// Zone 14
	115,															// Zone 15
	116 															// Zone 16
}  

VOLATILE INTEGER nRendererNameText[] =
{
	121,															// Zone 01
	122,															// Zone 02
	123,															// Zone 03
	124,															// Zone 04
	125,															// Zone 05
	126,															// Zone 06
	127,															// Zone 07
	128,															// Zone 08
	129,															// Zone 09
	130,															// Zone 10
	131,															// Zone 11
	132,															// Zone 12
	133,															// Zone 13
	134,															// Zone 14
	135,															// Zone 15
	136 															// Zone 16
} 

VOLATILE INTEGER nRendererSourceText[] =
{
	141,															// Zone 01
	142,															// Zone 02
	143,															// Zone 03
	144,															// Zone 04
	145,															// Zone 05
	146,															// Zone 06
	147,															// Zone 07
	148,															// Zone 08
	149,															// Zone 09
	150,															// Zone 10
	151,															// Zone 11
	152,															// Zone 12
	153,															// Zone 13
	154,															// Zone 14
	155,															// Zone 15
	156 															// Zone 16
}

VOLATILE INTEGER nRendererVolumeText[] =
{
	161,															// Zone 01
	162,															// Zone 02
	163,															// Zone 03
	164,															// Zone 04
	165,															// Zone 05
	166,															// Zone 06
	167,															// Zone 07
	168,															// Zone 08
	169,															// Zone 09
	170,															// Zone 10
	171,															// Zone 11
	172,															// Zone 12
	173,															// Zone 13
	174,															// Zone 14
	175,															// Zone 15
	176 															// Zone 16
}
(***********************************************************)
(*               LATCHING DEFINITIONS GO BELOW             *)
(***********************************************************)
DEFINE_LATCHING

(***********************************************************)
(*       MUTUALLY EXCLUSIVE DEFINITIONS GO BELOW           *)
(***********************************************************)
DEFINE_MUTUALLY_EXCLUSIVE

(***********************************************************)
(*        SUBROUTINE/FUNCTION DEFINITIONS GO BELOW         *)
(***********************************************************)

////////////////////////////////////////////////////////////
// clearSourceList
////////////////////////////////////////////////////////////
DEFINE_FUNCTION clearSourceList()
{
	STACK_VAR INTEGER itemNum;

	FOR (itemNum = 1; itemNum <= MAX_SOURCES; itemNum++)
	{
		cSourceNames[MAX_SOURCES] = "";
	}
}

////////////////////////////////////////////////////////////
// Display_SourceList
////////////////////////////////////////////////////////////
DEFINE_FUNCTION Display_SourceList()
{
	STACK_VAR INTEGER nItem;
	
	FOR (nItem = 1; nItem <= SOURCE_PAGE_SIZE; nItem++)
	{
		SEND_COMMAND dvPanel,"'^TXT-',ITOA(nSelectSourceBtns[nItem]),',0,',cSourcePage[nItem]";
	}
}

////////////////////////////////////////////////////////////
// Select_Source
////////////////////////////////////////////////////////////
DEFINE_FUNCTION INTEGER Select_Source(INTEGER item)
{
	STACK_VAR INTEGER baseSourceIndex;
	STACK_VAR INTEGER nInput;

	baseSourceIndex = ((uPageListCtrl.nCurrentPage - 1) * SOURCE_PAGE_SIZE);

	nInput = baseSourceIndex + item;
	
	IF (cSourceNames[nInput] == "")
		nInput = 0;
                                                  
	RETURN nInput;
}

////////////////////////////////////////////////////////////
// Clear_SourceList
////////////////////////////////////////////////////////////
DEFINE_FUNCTION Clear_SourceList()
{
	STACK_VAR INTEGER nItem;
	
	FOR (nItem = 1; nItem <= SOURCE_PAGE_SIZE; nItem++)
		cSourcePage[nItem] = "";
		
	Display_SourceList();
}

////////////////////////////////////////////////////////////
// Page_SourceList
////////////////////////////////////////////////////////////
DEFINE_FUNCTION Page_SourceList(INTEGER nPage)
{
	STACK_VAR INTEGER baseSourceIndex;
	STACK_VAR INTEGER nItem;

	IF (nPage > 0 && nPage <= uPageListCtrl.nQtyOfPages)
	{
		baseSourceIndex = ((nPage - 1) * SOURCE_PAGE_SIZE);
		
		FOR (nItem = 1; nItem <= SOURCE_PAGE_SIZE; nItem++)
			cSourcePage[nItem] = cSourceNames[baseSourceIndex + nItem];                                              

		uPageListCtrl.nCurrentPage = nPage;

		uPageListCtrl.Is_Top = (uPageListCtrl.nCurrentPage == 1);
		uPageListCtrl.Is_Bottom = (uPageListCtrl.nCurrentPage == uPageListCtrl.nQtyOfPages);
		
		Display_SourceList();
	}
}                                                                                

////////////////////////////////////////////////////////////
// Update_SourceList
////////////////////////////////////////////////////////////
DEFINE_FUNCTION Update_SourceList(INTEGER nCount)
{
	IF (uPageListCtrl.nCurrentCount != nCount)
	{
		uPageListCtrl.nCurrentCount = nCount;
		
		IF (uPageListCtrl.nCurrentCount > 0)
		{
			uPageListCtrl.nQtyOfPages = (((uPageListCtrl.nCurrentCount - 1) / SOURCE_PAGE_SIZE) + 1);
			uPageListCtrl.nQtyEntriesOnLastPage = (((uPageListCtrl.nCurrentCount - 1) % SOURCE_PAGE_SIZE) + 1);
		
			IF (uPageListCtrl.nCurrentPage = 0 || uPageListCtrl.nCurrentPage > uPageListCtrl.nQtyOfPages)
				uPageListCtrl.nCurrentPage = 1;
				
			Page_SourceList(uPageListCtrl.nCurrentPage);
		}
		ELSE
		{
			uPageListCtrl.nQtyOfPages = 0;
			uPageListCtrl.nQtyEntriesOnLastPage = 0;
			uPageListCtrl.nCurrentPage = 0;

			uPageListCtrl.Is_Top = TRUE;
			uPageListCtrl.Is_Bottom = TRUE;

			Clear_SourceList();
		}
	}
        
	IF (nCount > 0)
	{
		uPageListCtrl.Is_Top = (uPageListCtrl.nCurrentPage = 1);
		uPageListCtrl.Is_Bottom = (uPageListCtrl.nCurrentPage = uPageListCtrl.nQtyOfPages);
	}
}

(***********************************************************)
(*                STARTUP CODE GOES BELOW                  *)
(***********************************************************)
DEFINE_START

TIMELINE_CREATE(TL_FEEDBACK, FEEDBACK_TIMES, 1, TIMELINE_ABSOLUTE, TIMELINE_REPEAT);

(***********************************************************)
(*                THE EVENTS GO BELOW                      *)
(***********************************************************)
DEFINE_EVENT

////////////////////////////////////////////////////////////
// SELECT ZONE
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, nZoneSelectBtns]
{
	PUSH:
	{
		nButton = GET_LAST(nZoneSelectBtns);
		
		dvSelectedZone = dvRendererZones[nButton];
		
		SEND_COMMAND dvPanel,'@PPN-SelectedZone;Main';
		
		// SELECTED TEXT UPDATE
		SEND_COMMAND dvPanel,"'^TXT-',ITOA(nSelectedRendererNameText),',0,',uRendererInfo[dvSelectedZone.PORT].cName"
		
		// SELECTED TEXT UPDATE
		IF (uRendererInfo[dvSelectedZone.PORT].nCurrentInput > 0)
			SEND_COMMAND dvPanel,"'^TXT-',ITOA(nSelectedSourceNameText),',0,',cSourceNames[uRendererInfo[dvSelectedZone.PORT].nCurrentInput]"
		ELSE
			SEND_COMMAND dvPanel,"'^TXT-',ITOA(nSelectedSourceNameText),',0,'"
	}
}

////////////////////////////////////////////////////////////
// ZONE CONTROL - Source Selection
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, nSelectSourceBtns]
{
	PUSH:
	{
		nButton = GET_LAST(nSelectSourceBtns);
		nSelectedSource = Select_Source(nButton);
	}
}
TIMELINE_EVENT[TL_FEEDBACK]
{
	FOR (nButton = 1; nButton <= MAX_LENGTH_ARRAY(nSelectSourceBtns); nButton++)
	{
		IF (nSelectedSource > 0)
			[dvPanel, nSelectSourceBtns[nButton]] = (cSourcePage[nButton] == cSourceNames[nSelectedSource] && cSourceNames[nSelectedSource] != "");
		ELSE
			[dvPanel, nSelectSourceBtns[nButton]] = FALSE;
	}
}

BUTTON_EVENT[dvPanel, nSelectedSourceBtn]
{
	PUSH:
	{
		IF (nSelectedSource > 0 && dvSelectedZone != dvNull)
		{
			TO[BUTTON.INPUT];
			
			SEND_COMMAND vdvStreamNet,"'CI',ITOA(nSelectedSource),'O',ITOA(dvSelectedZone.PORT)";
			
			nSelectedSource = 0;
		}
	}
}

BUTTON_EVENT[dvPanel, nPageControlBtns]
{
	PUSH:
	{
		nButton = GET_LAST(nPageControlBtns);
		
		SWITCH (nButton)
		{
			CASE 1: // TOP
			{
				IF (uPageListCtrl.Is_Top == FALSE)
					Page_SourceList(1);
			}
			CASE 2: // BOTTOM
			{
				IF (uPageListCtrl.Is_Bottom == FALSE)
					Page_SourceList(uPageListCtrl.nQtyOfPages);
			}
			CASE 3: // UP
			{
				TO[BUTTON.INPUT];
				
				IF (uPageListCtrl.Is_Top == FALSE)
					Page_SourceList(uPageListCtrl.nCurrentPage - 1);
			}
			CASE 4: // DOWN
			{
				TO[BUTTON.INPUT];

				IF (uPageListCtrl.Is_Bottom == FALSE)
					Page_SourceList(uPageListCtrl.nCurrentPage + 1);
			}
		}
	}
}

TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, nPageControlBtns[1]] = (uPageListCtrl.Is_Top == TRUE);
	[dvPanel, nPageControlBtns[2]] = (uPageListCtrl.Is_Bottom == TRUE);
}

////////////////////////////////////////////////////////////
// SELECTED RENDERER CONTROL
////////////////////////////////////////////////////////////
BUTTON_EVENT[dvPanel, nSelectedAVModeBtn]
{
	PUSH:
	{
		PULSE[dvSelectedZone, AV_MODE_CYCLE];
	}
}
TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, nSelectedAVModeBtn] = [dvSelectedZone, AV_MODE_FB];
}

BUTTON_EVENT[dvPanel, nSelectedMultiRoomBtn]
{
	PUSH:
	{
		PULSE[dvSelectedZone, MROOM_SESSION_ACTIVE_CYCLE];
	}
}
TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, nSelectedMultiRoomBtn] = [dvSelectedZone, MROOM_SESSION_ACTIVE_FB];
}

BUTTON_EVENT[dvPanel, nSelectedVolumeCtrlBtns]
{
	PUSH:
	{
		nButton = GET_LAST(nSelectedVolumeCtrlBtns);
		
		SWITCH (nButton)
		{
			CASE 1: // VOLUME UP
			{
				TO[dvSelectedZone, VOL_UP];
			}
			CASE 2: // VOLUME DN
			{
				TO[dvSelectedZone, VOL_DN];
			}
			CASE 3: // VOLUME MUTE
			{
				PULSE[dvSelectedZone, VOL_MUTE];
			}
		}
	}
}
TIMELINE_EVENT[TL_FEEDBACK]
{
	[dvPanel, nSelectedVolumeCtrlBtns[1]] = [dvSelectedZone, VOL_UP_FB];
	[dvPanel, nSelectedVolumeCtrlBtns[2]] = [dvSelectedZone, VOL_DN_FB];
	[dvPanel, nSelectedVolumeCtrlBtns[3]] = [dvSelectedZone, VOL_MUTE_FB];
	
	IF (dvSelectedZone != dvNull)
	{
		SEND_LEVEL dvPanel, VOL_LVL, uRendererInfo[dvSelectedZone.PORT].nCurrentVolumeLevel;
	}
}

////////////////////////////////////////////////////////////
// StreamNet Duet DATA_EVENTS
////////////////////////////////////////////////////////////
DATA_EVENT[vdvStreamNet]
{
	ONLINE:
	{
		Update_SourceList(0);
	}
	COMMAND:
	{
		STACK_VAR CHAR cHeader[DUET_MAX_HDR_LEN];
		STACK_VAR CHAR cParam[DUET_MAX_PARAM_LEN];
		STACK_VAR INTEGER nParam;
		
		cHeader = DuetParseCmdHeader(DATA.TEXT);
		
		SELECT
		{
			// SOURCE_NAME-<INPUT>,<NAME>
			ACTIVE (cHeader == 'SOURCE_NAME'):
			{
				nParam = ATOI(DuetParseCmdParam(DATA.TEXT));
				
				IF (nParam >= 1 && nParam <= MAX_SOURCES)
				{
					cSourceNames[nParam] = DuetParseCmdParam(DATA.TEXT);
					
					// valid source name, so set count;
					IF (nSourceCount < nParam && cSourceNames[nParam] != '')
					{
						nSourceCount = nParam;
					
						CANCEL_WAIT 'UPDATE SOURCE LIST'
						WAIT 5 'UPDATE SOURCE LIST'
							Update_SourceList(nSourceCount);
					}
				}
			}
			// SWITCH-LALLI<INPUT>O<OUTPUT>
			ACTIVE (cHeader == 'SWITCH'):
			{
				cParam = DuetParseCmdParam(DATA.TEXT);
				
				// VALID ALL LEVEL
				IF (FIND_STRING(cParam,'LALLI',1) > 0)
				{
					STACK_VAR INTEGER nInput;
					STACK_VAR INTEGER nOutput;
					
					REMOVE_STRING(cParam,'LALLI',1);
					
					nInput = ATOI(REMOVE_STRING(cParam,'O',1));
					nOutput = ATOI(cParam);
					
					IF (nOutput > 0 && nOutput <= MAX_RENDERERS)
					{
						uRendererInfo[nOutput].nCurrentInput = nInput;
						
						// DEDICATED TEXT UPDATE
						IF (nOutput <= MAX_LENGTH_ARRAY(nRendererSourceText))
						{
							IF (uRendererInfo[nOutput].nCurrentInput > 0)
								SEND_COMMAND dvPanel,"'^TXT-',ITOA(nRendererSourceText[nOutput]),',0,',cSourceNames[uRendererInfo[nOutput].nCurrentInput]";
							ELSE
								SEND_COMMAND dvPanel,"'^TXT-',ITOA(nRendererSourceText[nOutput]),',0,'";
						}
							
						// SELECTED TEXT UPDATE
						IF (dvSelectedZone != dvNull && nOutput == dvSelectedZone.PORT)
						{
							IF (uRendererInfo[dvSelectedZone.PORT].nCurrentInput > 0)
								SEND_COMMAND dvPanel,"'^TXT-',ITOA(nSelectedSourceNameText),',0,',cSourceNames[uRendererInfo[dvSelectedZone.PORT].nCurrentInput]"
							ELSE
								SEND_COMMAND dvPanel,"'^TXT-',ITOA(nSelectedSourceNameText),',0,'"
						}
					}
				}
			}
		}
	}
}

DATA_EVENT[dvRendererZones]
{
	COMMAND:
	{
		STACK_VAR CHAR cHeader[DUET_MAX_HDR_LEN];
		STACK_VAR CHAR cParam[DUET_MAX_PARAM_LEN];
		STACK_VAR INTEGER nParam;
		STACK_VAR INTEGER nZone;
		
		cHeader = DuetParseCmdHeader(DATA.TEXT);
		
		nZone = DATA.DEVICE.PORT;

		IF (nZone > 0 && nZone <= MAX_RENDERERS)
		{
			SELECT
			{
				ACTIVE (cHeader == 'DISPLAY_NAME'):
				{
					cParam = DuetParseCmdParam(DATA.TEXT);
					
					uRendererInfo[nZone].cName = cParam;
					
					// DEDICATED TEXT UPDATE
					IF (nZone <= MAX_LENGTH_ARRAY(nRendererNameText))
						SEND_COMMAND dvPanel,"'^TXT-',ITOA(nRendererNameText[nZone]),',0,',uRendererInfo[nZone].cName";
				}
			}
		}
	}
}

////////////////////////////////////////////////////////////
// StreamNet Duet CHANNEL_EVENTS
////////////////////////////////////////////////////////////
CHANNEL_EVENT[dvRendererZones, IS_CONFIGURED]
{
	ON:
	{
		SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererZoneSelectText[CHANNEL.DEVICE.PORT]),',1'"
		SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererNameText[CHANNEL.DEVICE.PORT]),',1'"
		SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererSourceText[CHANNEL.DEVICE.PORT]),',1'"
		SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererVolumeText[CHANNEL.DEVICE.PORT]),',1'"
	}
	OFF:
	{
		SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererZoneSelectText[CHANNEL.DEVICE.PORT]),',0'"
		SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererNameText[CHANNEL.DEVICE.PORT]),',0'"
		SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererSourceText[CHANNEL.DEVICE.PORT]),',0'"
		SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererVolumeText[CHANNEL.DEVICE.PORT]),',0'"
	}
}

////////////////////////////////////////////////////////////
// StreamNet Duet LEVEL_EVENTS
///////////////////////////////////////////////////////////
LEVEL_EVENT[dvRendererZones, VOL_LVL]
{
	STACK_VAR INTEGER nZone;

	nZone = LEVEL.INPUT.DEVICE.PORT;
	
	IF (nZone > 0 && nZone <= MAX_RENDERERS)
	{
		uRendererInfo[nZone].nCurrentVolumeLevel = LEVEL.VALUE;
		
		IF (nZone <= MAX_LENGTH_ARRAY(nRendererVolumeText))
			SEND_COMMAND dvPanel,"'^TXT-',ITOA(nRendererVolumeText[nZone]),',0,',ITOA((LEVEL.VALUE * 100) / 255),'%'";
	}
}

////////////////////////////////////////////////////////////
// TP ONLINE
////////////////////////////////////////////////////////////
DATA_EVENT[dvPanel]
{
	ONLINE:
	{
		LOCAL_VAR INTEGER nZone;

		WAIT 50 'TP SETTLE'
		{
			SEND_COMMAND dvPanel,'@PPX';
			
			IF ([vdvStreamnet, DATA_INITIALIZED] == TRUE)
			{
				Display_SourceList();
			
				FOR (nZone = 1; nZone <= MAX_RENDERERS; nZone++)
				{
					// SHOW RENDERERS IF CONFIGURED
					IF ([dvRendererZones[nZone], IS_CONFIGURED] == TRUE)
					{
							SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererZoneSelectText[nZone]),',1'"
							SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererNameText[nZone]),',1'"
							SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererSourceText[nZone]),',1'"
							SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererVolumeText[nZone]),',1'"
					}
					ELSE
					{
							SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererZoneSelectText[nZone]),',0'"
							SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererNameText[nZone]),',0'"
							SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererSourceText[nZone]),',0'"
							SEND_COMMAND dvPanel,"'^SHO-',ITOA(nRendererVolumeText[nZone]),',0'"
					}				
					
					// DEDICATED RENDERER TEXT
					SEND_COMMAND dvPanel,"'^TXT-',ITOA(nRendererNameText[nZone]),',0,',uRendererInfo[nZone].cName";
					
					// DEDICATED SOURCE TEXT
					IF (uRendererInfo[nZone].nCurrentInput > 0)
						SEND_COMMAND dvPanel,"'^TXT-',ITOA(nRendererSourceText[nZone]),',0,',cSourceNames[uRendererInfo[nZone].nCurrentInput]";
					ELSE
						SEND_COMMAND dvPanel,"'^TXT-',ITOA(nRendererSourceText[nZone]),',0,'";
							
					// DEDICATED VOLUME TEXT		
					SEND_COMMAND dvPanel,"'^TXT-',ITOA(nRendererVolumeText[nZone]),',0,',ITOA((uRendererInfo[nZone].nCurrentVolumeLevel * 100) / 255),'%'";
				}
			}
		}
	}
}

(***********************************************************)
(*            THE ACTUAL PROGRAM GOES BELOW                *)
(***********************************************************)
DEFINE_PROGRAM

(***********************************************************)
(*                     END OF PROGRAM                      *)
(*        DO NOT PUT ANY CODE BELOW THIS COMMENT           *)
(***********************************************************)
